Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs	(revision 14332)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs	(revision 14333)
@@ -550,134 +248,43 @@
       return matrix;
     }
+    #endregion
 
     #region event handlers
     private void RegisterEvents() {
-      ProblemDataParameter.ValueChanged += OnProblemDataChanged;
-      ModelCollectionParameter.Value.ItemsAdded += ModelCollection_OnItemsAdded;
-      ModelCollectionParameter.Value.ItemsRemoved += ModelCollection_OnItemsRemoved;
-      RowParameter.Value.ValueChanged += OnRowChanged;
-      ControllableParameters.CheckedItemsChanged += ControllableParameters_OnItemsChanged;
-      ControllableParameterBounds.ItemChanged += ControllableParameterBounds_ItemChanged;
-    }
-
-    private void OnRowChanged(object o, EventArgs e) {
-      // set variables in the modifiable dataset according to the new row
-      foreach (var v in dataset.DoubleVariables)
-        dataset.SetVariableValue(ProblemData.Dataset.GetDoubleValue(v, Row), v, 0);
-      // set the correct targets
-      UpdateTargetList();
-    }
-
-    private void OnProblemDataChanged(object o, EventArgs e) {
-      try {
-        ProblemData = ProblemDataParameter.Value;
-      }
-      catch (ArgumentException exception) {
-        MessageBox.Show(exception.Message, "Update Problem Data", MessageBoxButtons.OK, MessageBoxIcon.Error);
-        ProblemDataParameter.Value = problemData;
-      }
-    }
-
-    private void ModelCollection_OnItemsAdded(object sender, CollectionItemsChangedEventArgs<IRegressionModel> e) {
-      if (e.Items == null) return;
-
-      var collection = (IObservableCollection<IRegressionModel>)sender;
-      var newItems = e.Items.ToList();
-
-      foreach (var model in e.Items) {
-        try {
-          CheckIfDatasetContainsTarget(model.TargetVariable);
-        }
-        catch (ArgumentException exception) {
-          MessageBox.Show(exception.Message, "Add Model", MessageBoxButtons.OK, MessageBoxIcon.Error);
-          newItems.Remove(model);
-          collection.Remove(model);
-        }
-      }
-      UpdateTargetList();
-      OnModelsChanged(this, EventArgs.Empty);
-    }
-
-    private void ModelCollection_OnItemsRemoved(object sender, CollectionItemsChangedEventArgs<IRegressionModel> e) {
-      if (e.Items == null) return;
-      UpdateTargetList();
-      OnModelsChanged(this, EventArgs.Empty);
-    }
-
-    private void ControllableParameters_OnItemsChanged(object o, CollectionItemsChangedEventArgs<IndexedItem<StringValue>> e) {
-      UpdateEncoding();
-    }
-
-    private void ControllableParameterBounds_ItemChanged(object o, EventArgs e) {
-      UpdateEncoding();
+      ModelsParameter.Value.ItemsAdded += ModelCollection_ItemsChanged;
+      ModelsParameter.Value.ItemsRemoved += ModelCollection_ItemsChanged;
+      GoalsParameter.Value.CheckedItemsChanged += GoalSeekingUtil.Goals_CheckedItemsChanged;
+      InputsParameter.Value.CheckedItemsChanged += GoalSeekingUtil.Inputs_CheckedItemsChanged;
+    }
+
+    private void ModelCollection_ItemsChanged(object sender, CollectionItemsChangedEventArgs<IRegressionModel> e) {
+      if (e.Items == null || !e.Items.Any()) return;
+      GoalSeekingUtil.UpdateInputs(InputsParameter.Value, Models, InputParameterChanged);
+      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
+      GoalSeekingUtil.UpdateTargets(GoalsParameter.Value, Models, GoalParameterChanged);
+      GoalSeekingUtil.RaiseEvent(this, ModelsChanged);
+    }
+
+    private void InputParameterChanged(object sender, EventArgs args) {
+      var inputParameter = (InputParameter)sender;
+      var inputs = InputsParameter.Value;
+      if (inputs.ItemChecked(inputParameter) != inputParameter.Active)
+        inputs.SetItemCheckedState(inputParameter, inputParameter.Active);
+      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
+    }
+
+    private void GoalParameterChanged(object sender, EventArgs args) {
+      var goalParameter = (GoalParameter)sender;
+      var goals = GoalsParameter.Value;
+      if (goals.ItemChecked(goalParameter) != goalParameter.Active)
+        goals.SetItemCheckedState(goalParameter, goalParameter.Active);
     }
     #endregion
 
     #region helper methods
-    private void UpdateControllableParameters() {
-      if (ProblemData == null) return;
-      var variablesUsedForPrediction = ModelCollection.Any()
-        ? ModelCollection.SelectMany(x => x.VariablesUsedForPrediction).Distinct()
-        : ProblemData.Dataset.DoubleVariables;
-      SetControllableParameters(variablesUsedForPrediction);
-    }
-
-    private void UpdateTargetList() {
-      if (ProblemData == null) return;
-      if (!Models.Any()) {
-        TargetGoals = new DoubleMatrix();
-        maximization = new[] { false };
-        MaximizationParameter.Value = (BoolArray)new BoolArray(maximization).AsReadOnly();
-        TargetList = new CheckedItemList<StringValue>();
-        return;
-      }
-
-      var targetNames = Models.Select(x => x.TargetVariable).Distinct().ToList();
-      var oldTargetGoals = (DoubleMatrix)TargetGoals.Clone();
-      var oldRowIndices = oldTargetGoals.RowNames.Select((x, i) => new { x, i }).ToDictionary(x => x.x, x => x.i);
-      TargetGoals = new DoubleMatrix(targetNames.Count, 4);
-      TargetGoals.RowNames = targetNames;
-      TargetGoals.ColumnNames = new[] { "Goal", "Weight", "Variance", "Step size" };
-
-      TargetList = new CheckedItemList<StringValue>();
-      for (int i = 0; i < targetNames.Count; ++i) {
-        TargetList.Add(new StringValue(targetNames[i]), true);
-        int rowIndex;
-        if (oldRowIndices.TryGetValue(targetNames[i], out rowIndex)) {
-          for (int j = 0; j < TargetGoals.Columns; ++j)
-            TargetGoals[i, j] = oldTargetGoals[rowIndex, j];
-        } else {
-          TargetGoals[i, 0] = ProblemData.Dataset.GetDoubleValue(targetNames[i], Row);
-          TargetGoals[i, 1] = 1.0;
-          TargetGoals[i, 2] = ProblemData.Dataset.GetReadOnlyDoubleValues(targetNames[i]).Variance();
-          TargetGoals[i, 3] = 1e-6;
-        }
-      }
-      maximization = new bool[targetNames.Count];
-      MaximizationParameter.Value = (BoolArray)new BoolArray(maximization).AsReadOnly();
-    }
-
-    private void UpdateEncoding() {
-      var activeParameters = ActiveParameters.ToList();
-      if (Encoding == null)
-        Encoding = new RealVectorEncoding(activeParameters.Count);
-      else
-        Encoding.Length = activeParameters.Count;
-
-      Encoding.Bounds = new DoubleMatrix(activeParameters.Count, 2); // only two columns: min and max
-      Encoding.Bounds.RowNames = activeParameters;
-      Encoding.Bounds.ColumnNames = new[] { "Min.", "Max." };
-
-      int i = 0;
-      foreach (var item in ControllableParameters.CheckedItems) {
-        var index = item.Index;
-        Encoding.Bounds[i, 0] = ControllableParameterBounds[index, 0];
-        Encoding.Bounds[i, 1] = ControllableParameterBounds[index, 1];
-        ++i;
-      }
-    }
-
-    private bool IsValidTarget(string target) {
-      return TargetList.Any(x => x.Value == target);
+    // method which throws an exception that can be caught in the event handler if the check fails
+    private void CheckIfDatasetContainsTarget(string target) {
+      if (dataset.DoubleVariables.All(x => x != target))
+        throw new ArgumentException(string.Format("Model target \"{0}\" does not exist in the dataset.", target));
     }
     private static double RoundToNearestStepMultiple(double value, double step) {
@@ -685,5 +292,5 @@
     }
     private IEnumerable<IRegressionModel> GetModels(string target) {
-      return ModelCollection.Where(x => x.TargetVariable == target);
+      return Models.Where(x => x.TargetVariable == target);
     }
     private class DoubleEqualityComparer : IEqualityComparer<double> {
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/PreBuildEvent.cmd	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/PreBuildEvent.cmd	(revision 14333)
@@ -0,0 +1,11 @@
+IF EXIST "%ProjectDir%\Properties\AssemblyInfo.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+IF EXIST "%ProjectDir%\Plugin.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Plugin.cs.frame" "%ProjectDir%\Plugin.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+GOTO Done
+
+:Error_Handling
+ECHO There was an error while running subwcrev. Please verify that the *.cs.frame files have been correctly converted to *.cs files, otherwise HeuristicLab won't build. 
+exit 0
+
+:Done
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/Properties/AssemblyInfo.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/Properties/AssemblyInfo.cs	(revision 14332)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/Properties/AssemblyInfo.cs	(revision 14333)
@@ -54,3 +54,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.11.14321")]
+[assembly: AssemblyFileVersion("3.3.11.14325")]
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/SingleObjectiveGoalSeekingProblem.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/SingleObjectiveGoalSeekingProblem.cs	(revision 14332)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/SingleObjectiveGoalSeekingProblem.cs	(revision 14333)
@@ -23,9 +23,7 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Windows.Forms;
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Optimization;
@@ -41,138 +39,163 @@
     #region parameter names
     private const string ModifiableDatasetParameterName = "Dataset";
-    private const string ProblemDataParameterName = "ProblemData";
-    private const string ControllableParametersParameterName = "ControllableParameters";
-    private const string ControllableParameterBoundsParameterName = "ControllableParameterBounds";
-    private const string TargetGoalsParameterName = "TargetGoals";
-    private const string TargetsParameterName = "Targets";
-    private const string ModelCollectionParameterName = "ModelCollection";
-    private const string RowParameterName = "Row";
-    // these parameters are used by the pareto folding analyzer
-    private const string AllowedRangesParameterName = "AllowedRanges";
-    private const string QualitySumCutoffParameterName = "QualitySumCutoff";
+    private const string InputsParameterName = "Inputs";
+    private const string GoalsParameterName = "Goals";
+    private const string ModelsParameterName = "Models";
     #endregion
 
     #region parameters
-    public IValueParameter<RealVector> AllowedRangesParameter {
-      get { return (IValueParameter<RealVector>)Parameters[AllowedRangesParameterName]; }
-    }
-    public IFixedValueParameter<DoubleValue> QualitySumCutoffParameter {
-      get { return (IFixedValueParameter<DoubleValue>)Parameters[QualitySumCutoffParameterName]; }
-    }
-    public IValueParameter<IRegressionProblemData> ProblemDataParameter {
-      get { return (IValueParameter<IRegressionProblemData>)Parameters[ProblemDataParameterName]; }
-    }
-    public IValueParameter<CheckedItemList<StringValue>> ControllableParametersParameter {
-      get { return (IValueParameter<CheckedItemList<StringValue>>)Parameters[ControllableParametersParameterName]; }
-    }
-    public IValueParameter<DoubleMatrix> ControllableParameterBoundsParameter {
-      get { return (IValueParameter<DoubleMatrix>)Parameters[ControllableParameterBoundsParameterName]; }
-    }
-    public IFixedValueParameter<ItemCollection<IRegressionModel>> ModelCollectionParameter {
-      get { return (IFixedValueParameter<ItemCollection<IRegressionModel>>)Parameters[ModelCollectionParameterName]; }
-    }
-    public IValueParameter<CheckedItemList<StringValue>> TargetsParameter {
-      get { return (IValueParameter<CheckedItemList<StringValue>>)Parameters[TargetsParameterName]; }
-    }
-    public IValueParameter<DoubleMatrix> TargetGoalsParameter {
-      get { return (IValueParameter<DoubleMatrix>)Parameters[TargetGoalsParameterName]; }
-    }
-    public IFixedValueParameter<IntValue> RowParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters[RowParameterName]; }
-    }
-    #endregion
-
-    #region parameter properties
-    private IItemCollection<IRegressionModel> ModelCollection {
-      get { return ModelCollectionParameter.Value; }
-    }
-    public DoubleMatrix TargetGoals {
-      get { return TargetGoalsParameter.Value; }
-      set { TargetGoalsParameter.Value = value; }
-    }
-    #endregion
-
-    #region IProcessParameterOptimizationProblem properties
-    [Storable]
-    private IRegressionProblemData problemData;
-    public IRegressionProblemData ProblemData {
-      get { return problemData; }
-      set {
-        if (value == null || value == problemData) return;
-        var variables = value.Dataset.DoubleVariables.ToList();
-        if (Models.Any()) {
-          var targets = Models.Select(x => x.TargetVariable);
-          var hashset = new HashSet<string>(variables);
-          foreach (var target in targets) {
-            if (!hashset.Contains(target)) {
-              throw new ArgumentException(string.Format("Incompatible problem data. Target \"{0}\" is missing.", target));
-            }
-          }
-        }
-        problemData = value;
-        dataset = new ModifiableDataset(variables, variables.Select(x => new List<double> { ProblemData.Dataset.GetDoubleValue(x, Row) }));
-        ProblemDataParameter.Value = ProblemData;
-        UpdateControllableParameters();
-        UpdateTargetList();
-      }
-    }
-
-    public int Row {
-      get { return RowParameter.Value.Value; }
-      set { RowParameter.Value.Value = value; }
-    }
-
+    public IValueParameter<CheckedItemList<InputParameter>> InputsParameter {
+      get { return (IValueParameter<CheckedItemList<InputParameter>>)Parameters[InputsParameterName]; }
+    }
+    public IValueParameter<CheckedItemList<GoalParameter>> GoalsParameter {
+      get { return (IValueParameter<CheckedItemList<GoalParameter>>)Parameters[GoalsParameterName]; }
+    }
+    public IFixedValueParameter<ItemCollection<IRegressionModel>> ModelsParameter {
+      get { return (IFixedValueParameter<ItemCollection<IRegressionModel>>)Parameters[ModelsParameterName]; }
+    }
+    #endregion
+
+    #region IGoalSeekingProblem implementation
     public IEnumerable<IRegressionModel> Models {
-      get { return ModelCollectionParameter.Value; }
-    }
-
-    #region targets
-    public ICheckedItemList<StringValue> TargetList {
-      get { return TargetsParameter.Value; }
-      set { TargetsParameter.Value = (CheckedItemList<StringValue>)value; }
-    }
-    private IEnumerable<string> ActiveTargets {
-      get { return TargetList.CheckedItems.Select(x => x.Value.Value); }
-    }
-    #endregion
-
-    #region parameters
-    private IEnumerable<string> ActiveParameters {
-      get { return ControllableParameters.CheckedItems.Select(x => x.Value.Value); }
-    }
-    public ICheckedItemList<StringValue> ControllableParameters {
-      get { return ControllableParametersParameter.Value; }
-      set { ControllableParametersParameter.Value = (CheckedItemList<StringValue>)value; }
-    }
-    public DoubleMatrix ControllableParameterBounds {
-      get { return ControllableParameterBoundsParameter.Value; }
-      set { ControllableParameterBoundsParameter.Value = value; }
-    }
-    #endregion
-    #endregion
-
-    #region IProcessParameterOptimizationProblem methods
-    #region solutions
+      get { return ModelsParameter.Value; }
+    }
+
+    public IEnumerable<GoalParameter> Goals {
+      get { return GoalsParameter.Value; }
+    }
+
+    public IEnumerable<InputParameter> Inputs {
+      get { return InputsParameter.Value; }
+    }
+
+    public void AddModel(IRegressionModel model) {
+      var models = ModelsParameter.Value;
+      models.Add(model);
+      GoalSeekingUtil.RaiseEvent(this, ModelsChanged);
+    }
+
+    public void RemoveModel(IRegressionModel model) {
+      var models = ModelsParameter.Value;
+      models.Remove(model);
+      GoalSeekingUtil.RaiseEvent(this, ModelsChanged);
+    }
+
+    public void Configure(IRegressionProblemData problemData, int row) {
+      GoalSeekingUtil.Configure(Goals, Inputs, problemData, row);
+    }
+
     public IEnumerable<double> GetEstimatedGoalValues(IEnumerable<double> parameterValues, bool round = false) {
       var ds = (ModifiableDataset)dataset.Clone();
-      foreach (var parameter in ActiveParameters.Zip(parameterValues, (p, v) => new { Name = p, Value = v })) {
+      foreach (var parameter in ActiveInputs.Zip(parameterValues, (p, v) => new { Name = p.Name, Value = v })) {
         ds.SetVariableValue(parameter.Value, parameter.Name, 0);
       }
       var rows = new[] { 0 }; // actually just one row
-
       var estimatedValues =
-        round ? ActiveTargets.Select(t => RoundToNearestStepMultiple(GetModels(t).Average(m => m.GetEstimatedValues(ds, rows).Single()), GetTargetStepSize(t)))
-              : ActiveTargets.Select(t => GetModels(t).Average(m => m.GetEstimatedValues(ds, rows).Single()));
-
+        round ? ActiveGoals.Select(t => RoundToNearestStepMultiple(GetModels(t.Name).Average(m => m.GetEstimatedValues(ds, rows).Single()), t.Step))
+              : ActiveGoals.Select(t => GetModels(t.Name).Average(m => m.GetEstimatedValues(ds, rows).Single()));
       return estimatedValues;
     }
 
-    public void AddModel(IRegressionModel model) {
-      var target = model.TargetVariable;
-      CheckIfDatasetContainsTarget(target);
-      ModelCollection.Add(model);
-      OnModelsChanged(this, EventArgs.Empty);
-    }
-
+    public event EventHandler ModelsChanged;
+    public event EventHandler TargetsChanged;
+    public event EventHandler ParametersChanged;
+    #endregion
+
+    private IEnumerable<GoalParameter> ActiveGoals {
+      get { return Goals.Where(x => x.Active); }
+    }
+    private IEnumerable<InputParameter> ActiveInputs {
+      get { return Inputs.Where(x => x.Active); }
+    }
+
+    [Storable]
+    private ModifiableDataset dataset; // modifiable dataset
+
+    public override bool Maximization {
+      get { return false; }
+    }
+
+    #region constructors
+    [StorableConstructor]
+    private SingleObjectiveGoalSeekingProblem(bool deserializing) : base(deserializing) { }
+
+    private SingleObjectiveGoalSeekingProblem(SingleObjectiveGoalSeekingProblem original, Cloner cloner) : base(original, cloner) {
+      this.dataset = cloner.Clone(original.dataset);
+      RegisterEvents();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleObjectiveGoalSeekingProblem(this, cloner);
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEvents();
+    }
+
+    public SingleObjectiveGoalSeekingProblem() {
+      dataset = new ModifiableDataset();
+      Parameters.Add(new ValueParameter<IDataset>(ModifiableDatasetParameterName, dataset) { Hidden = true });
+      Parameters.Add(new ValueParameter<CheckedItemList<InputParameter>>(InputsParameterName));
+      Parameters.Add(new ValueParameter<CheckedItemList<GoalParameter>>(GoalsParameterName));
+      Parameters.Add(new FixedValueParameter<ItemCollection<IRegressionModel>>(ModelsParameterName, new ItemCollection<IRegressionModel>()));
+      EncodingParameter.Hidden = true;
+      EvaluatorParameter.Hidden = true;
+      SolutionCreatorParameter.Hidden = true;
+      GoalSeekingUtil.UpdateInputs(InputsParameter.Value, Models, InputParameterChanged);
+      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
+      GoalSeekingUtil.UpdateTargets(GoalsParameter.Value, Models, GoalParameterChanged);
+      RegisterEvents();
+    }
+    #endregion
+
+    public override double Evaluate(Individual individual, IRandom random) {
+      var vector = individual.RealVector();
+      vector.ElementNames = ActiveInputs.Select(x => x.Name);
+      int i = 0;
+      // round vector according to parameter step sizes
+      foreach (var parameter in ActiveInputs) {
+        vector[i] = RoundToNearestStepMultiple(vector[i], parameter.Step);
+        ++i;
+      }
+      var estimatedValues = GetEstimatedGoalValues(vector, round: true);
+      var quality = ActiveGoals.Zip(estimatedValues, (t, v) => new { Target = t, EstimatedValue = v })
+                               .Average(x => x.Target.Weight * Math.Pow(x.EstimatedValue - x.Target.Goal, 2) / x.Target.Variance);
+      return quality;
+    }
+    #region event handlers
+
+    private void RegisterEvents() {
+      ModelsParameter.Value.ItemsAdded += ModelCollection_ItemsChanged;
+      ModelsParameter.Value.ItemsRemoved += ModelCollection_ItemsChanged;
+      GoalsParameter.Value.CheckedItemsChanged += GoalSeekingUtil.Goals_CheckedItemsChanged;
+      InputsParameter.Value.CheckedItemsChanged += GoalSeekingUtil.Inputs_CheckedItemsChanged;
+    }
+
+    private void ModelCollection_ItemsChanged(object sender, CollectionItemsChangedEventArgs<IRegressionModel> e) {
+      if (e.Items == null || !e.Items.Any()) return;
+      GoalSeekingUtil.UpdateInputs(InputsParameter.Value, Models, InputParameterChanged);
+      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
+      GoalSeekingUtil.UpdateTargets(GoalsParameter.Value, Models, GoalParameterChanged);
+      GoalSeekingUtil.RaiseEvent(this, ModelsChanged);
+    }
+
+    private void InputParameterChanged(object sender, EventArgs args) {
+      var inputParameter = (InputParameter)sender;
+      var inputs = InputsParameter.Value;
+      if (inputs.ItemChecked(inputParameter) != inputParameter.Active)
+        inputs.SetItemCheckedState(inputParameter, inputParameter.Active);
+      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
+    }
+
+    private void GoalParameterChanged(object sender, EventArgs args) {
+      var goalParameter = (GoalParameter)sender;
+      var goals = GoalsParameter.Value;
+      if (goals.ItemChecked(goalParameter) != goalParameter.Active)
+        goals.SetItemCheckedState(goalParameter, goalParameter.Active);
+    }
+    #endregion
+
+    #region helper methods
     // method which throws an exception that can be caught in the event handler if the check fails
     private void CheckIfDatasetContainsTarget(string target) {
